Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_predict.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_predict.cpp	(revision 98)
@@ -24,16 +24,12 @@
     log_begin(Prediction_unit_Glue,FUNCTION);
     log_function(Prediction_unit_Glue,FUNCTION,_name.c_str());
-    
+
+    if (PORT_READ(in_NRESET))
+      {
+  
+    // Init
     Tcontrol_t ack [_param->_nb_context];
     for (uint32_t i=0; i<_param->_nb_context; i++)
-      {
-        ack [i] = 0;
-
-//      if (_param->_have_port_depth)
-//        {
-//      PORT_WRITE(out_DEPTH_TAIL      [i],PORT_READ(in_DEPTH_UPT_TAIL      [i]));
-//        }
-//      PORT_WRITE(out_DEPTH_NB_BRANCH [i],PORT_READ(in_DEPTH_UPT_NB_BRANCH [i]));
-      }
+      ack [i] = 0;
 
     for (uint32_t i=0; i<_param->_nb_inst_branch_predict; i++)
@@ -41,22 +37,27 @@
         log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"  * PREDICT [%d]",i);
 
-        Tcontrol_t btb_val;
-        Tcontrol_t dir_val;
-        Tcontrol_t ras_val;
-        Tcontrol_t upt_val;
-
-        Tcontext_t context = (reg_PREDICT_PRIORITY+i)%_param->_nb_context;
+        Tcontrol_t btb_val = false;
+        Tcontrol_t dir_val = false;
+        Tcontrol_t ras_val = false;
+        Tcontrol_t upt_val = false;
+
+        Tcontrol_t btb_ack = PORT_READ(in_PREDICT_BTB_ACK [i]);
+        Tcontrol_t dir_ack = PORT_READ(in_PREDICT_DIR_ACK [i]);
+        Tcontrol_t ras_ack = PORT_READ(in_PREDICT_RAS_ACK [i]);
+        Tcontrol_t upt_ack = PORT_READ(in_PREDICT_UPT_ACK [i]);
+
+        Tcontext_t context = (reg_PREDICT_PRIORITY+i)%_param->_nb_context; // priority
         log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * context    : %d",context);
 
         ack [context] = 1;
-            
+
         if (PORT_READ(in_PREDICT_VAL[context]) == 0)
           {
             log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * not valid ...");
 
-            btb_val = false;
-            dir_val = false;
-            ras_val = false;
-            upt_val = false;
+//             btb_val = false;
+//             dir_val = false;
+//             ras_val = false;
+//             upt_val = false;
           }
         else
@@ -67,4 +68,8 @@
             Taddress_t          pc_current            = PORT_READ(in_PREDICT_PC_CURRENT            [context]);
             Tcontrol_t          pc_current_is_ds_take = PORT_READ(in_PREDICT_PC_CURRENT_IS_DS_TAKE [context]);
+
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * pc_previous           : 0x%.8x",pc_previous          );
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * pc_current            : 0x%.8x",pc_current           );
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * pc_current_is_ds_take : %d"    ,pc_current_is_ds_take);
 
             Taddress_t          pc_next                     ;
@@ -75,17 +80,26 @@
             
             // STEP (1) - Compute the address source
+            // if pc_current is a ds take, then pc_previous is a branchement
             Taddress_t          address     = (pc_current_is_ds_take)?pc_previous:pc_current;
             Taddress_t          address_lsb = pc_current%_param->_nb_instruction [context]; //if pc_current_is_ds_take, then pc_current%_param->_nb_instruction [context] == 0
             Taddress_t          address_msb;
 
-            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * address    : 0x%x",address);
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * address               : 0x%.8x",address);
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * address_lsb           : %d"    ,address_lsb);
 
             // STEP (2) - Test if branch (access at branch_target_buffer)
             btb_val = true;
-            ack [context] &= PORT_READ(in_PREDICT_BTB_ACK [i]);
 
             if (_param->_have_port_context_id)
             PORT_WRITE(out_PREDICT_BTB_CONTEXT_ID [i],context);
             PORT_WRITE(out_PREDICT_BTB_ADDRESS    [i],address);
+
+            ack [context] &= btb_ack;
+
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * btb_ack               : %d"    ,btb_ack);
+
+            // BTB_ack = 0 ?
+            if (not btb_ack)
+              continue;
 
             // special case :
@@ -95,20 +109,26 @@
             Tcontrol_t          is_accurate = PORT_READ(in_PREDICT_BTB_IS_ACCURATE  [i]) and not (pc_current_is_ds_take and not hit);
 
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * hit                   : %d"    ,hit);
+            log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * is_accurate           : %d"    ,is_accurate);
+
             // STEP (3) : Test if have branch in the packet
             if (hit == 1)
               {
                 // STEP (3a) : branch - test condition
-
                 bool                use_dir      = false;
                 bool                use_ras      = false;
                 bool                use_upt      = false;
                 
-                Tbranch_condition_t cond         = PORT_READ(in_PREDICT_BTB_CONDITION    [i]);
+                Tbranch_condition_t condition    = PORT_READ(in_PREDICT_BTB_CONDITION    [i]);
                 Taddress_t          address_src  = PORT_READ(in_PREDICT_BTB_ADDRESS_SRC  [i]);
                 Taddress_t          address_dest = PORT_READ(in_PREDICT_BTB_ADDRESS_DEST [i]);
-                Tcontrol_t          push;
+                Tcontrol_t          push     ;
                 Tcontrol_t          direction;
 
-                switch (cond)
+                log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * condition             : %s"    ,toString(condition).c_str());
+                log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * address_src           : 0x%.8x",address_src);
+                log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * address_dest          : 0x%.8x",address_dest);
+
+                switch (condition)
                   {
                   case BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK          : // l.j
@@ -188,5 +208,5 @@
                 if (use_dir)
                   {
-                    ack[context] &= PORT_READ(in_PREDICT_DIR_ACK [i]);
+                    ack[context] &= dir_ack;
                     PORT_WRITE(out_PREDICT_DIR_ADDRESS_SRC [i], address_src);
                     PORT_WRITE(out_PREDICT_DIR_STATIC      [i], address_dest<address_src); // if destination is previous : the static direction is take
@@ -196,5 +216,5 @@
                 if (use_ras)
                   {
-                    ack[context] &= PORT_READ(in_PREDICT_RAS_ACK [i]);
+                    ack[context] &= ras_ack;
                     if (_param->_have_port_context_id)
                     PORT_WRITE(out_PREDICT_RAS_CONTEXT_ID   [i], context);
@@ -207,10 +227,11 @@
                 if (use_upt)
                   {
-                    ack[context] &= PORT_READ(in_PREDICT_UPT_ACK [i]);
+                    ack[context] &= upt_ack;
                     
+                    if (_param->_have_port_context_id)
                     PORT_WRITE(out_PREDICT_UPT_CONTEXT_ID       [i],context);
                     PORT_WRITE(out_PREDICT_UPT_BTB_ADDRESS_SRC  [i],address_src);
                     PORT_WRITE(out_PREDICT_UPT_BTB_ADDRESS_DEST [i],address_dest);
-                    PORT_WRITE(out_PREDICT_UPT_BTB_CONDITION    [i],cond);
+                    PORT_WRITE(out_PREDICT_UPT_BTB_CONDITION    [i],condition);
                     PORT_WRITE(out_PREDICT_UPT_BTB_LAST_TAKE    [i],direction);
                     PORT_WRITE(out_PREDICT_UPT_BTB_IS_ACCURATE  [i],is_accurate);
@@ -225,23 +246,33 @@
                 //   * use_ras and ras_ack
                 //   * use_upt and upt_ack
-//              ack [context] = (PORT_READ(in_PREDICT_BTB_ACK [i]) and 
-//                               (use_dir and PORT_READ(in_PREDICT_DIR_ACK [i])) and 
-//                               (use_ras and PORT_READ(in_PREDICT_RAS_ACK [i])) and 
-//                               (use_upt and PORT_READ(in_PREDICT_UPT_ACK [i])));
-
-                dir_val = (use_dir and
-                           PORT_READ(in_PREDICT_BTB_ACK [i]) and 
-                           (not use_ras or (use_ras and PORT_READ(in_PREDICT_RAS_ACK [i]))) and 
-                           (not use_upt or (use_upt and PORT_READ(in_PREDICT_UPT_ACK [i]))));
-
-                ras_val = (use_ras and
-                           PORT_READ(in_PREDICT_BTB_ACK [i]) and 
-                           (not use_dir or (use_dir and PORT_READ(in_PREDICT_DIR_ACK [i]))) and 
-                           (not use_upt or (use_upt and PORT_READ(in_PREDICT_UPT_ACK [i]))));
-
-                upt_val = (use_upt and
-                           PORT_READ(in_PREDICT_BTB_ACK [i]) and 
-                           (not use_dir or (use_dir and PORT_READ(in_PREDICT_DIR_ACK [i]))) and 
-                           (not use_ras or (use_ras and PORT_READ(in_PREDICT_RAS_ACK [i]))));
+//              ack [context] = (btb_ack and 
+//                               (use_dir and dir_ack) and 
+//                               (use_ras and ras_ack) and 
+//                               (use_upt and upt_ack));
+
+                dir_val = (btb_ack and 
+                           use_dir and
+//                         use_ras and
+//                         use_upt and
+//                         (not use_dir or (use_dir and dir_ack)) and 
+                           (not use_ras or (use_ras and ras_ack)) and 
+                           (not use_upt or (use_upt and upt_ack)));
+
+                ras_val = (btb_ack and 
+//                         use_dir and
+                           use_ras and
+//                         use_upt and
+                           (not use_dir or (use_dir and dir_ack)) and 
+//                         (not use_ras or (use_ras and ras_ack)) and 
+                           (not use_upt or (use_upt and upt_ack)));
+
+                upt_val = (btb_ack and 
+//                         use_dir and
+//                         use_ras and
+                           use_upt and
+                           (not use_dir or (use_dir and dir_ack)) and 
+                           (not use_ras or (use_ras and ras_ack))//  and 
+//                         (not use_upt or (use_upt and upt_ack))
+                           );
 
 //              pc_next      - is previously computed
@@ -252,4 +283,5 @@
                 log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * address_src     : 0x%x",address_src);
                 log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * address_src_lsb : %d",address_src_lsb);
+
                 if (address_src_lsb == (_param->_nb_instruction [context]-1))
                   {
@@ -288,15 +320,18 @@
               PORT_WRITE(out_PREDICT_PC_NEXT_IS_DS_TAKE          [context]   , pc_next_is_ds_take         );
 
+              Taddress_t address_limit_min = address_lsb;
+              Taddress_t address_limit_max = ((pc_current_is_ds_take)?(address_lsb+1):address_msb);
+
               log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * instruction enable :");
               log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * nb_inst : %d",_param->_nb_instruction [context]);
-              log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * [0:%d[ = 0",address_lsb);
-              log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * [%d:%d[ = 1",address_lsb,((pc_current_is_ds_take)?1:address_msb));
-              log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * [%d:%d[ = 0",((pc_current_is_ds_take)?1:address_msb),_param->_nb_instruction [context]);
-
-              for (uint32_t j=0; j<address_lsb; j++)
+              log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * [0:%d[ = 0" ,address_limit_min);
+              log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * [%d:%d[ = 1",address_limit_min,address_limit_max);
+              log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * [%d:%d[ = 0",address_limit_max,_param->_nb_instruction [context]);
+
+              for (uint32_t j=0; j<address_limit_min; j++)
               PORT_WRITE(out_PREDICT_INSTRUCTION_ENABLE          [context][j], 0); // Before the address : not valid
-              for (uint32_t j=address_lsb; j<((pc_current_is_ds_take)?1:address_msb); j++)
+              for (uint32_t j=address_limit_min; j<address_limit_max; j++)
               PORT_WRITE(out_PREDICT_INSTRUCTION_ENABLE          [context][j], 1); // Vald packet
-              for (uint32_t j=((pc_current_is_ds_take)?1:address_msb); j<_param->_nb_instruction [context]; j++)
+              for (uint32_t j=address_limit_max; j<_param->_nb_instruction [context]; j++)
               PORT_WRITE(out_PREDICT_INSTRUCTION_ENABLE          [context][j], 0); // After last address (branch) : not valid
               if (_param->_have_port_inst_ifetch_ptr)
@@ -316,4 +351,5 @@
     for (uint32_t i=0; i<_param->_nb_context; i++)
       PORT_WRITE(out_PREDICT_ACK[i],ack[i]);
+      }
 
     log_end(Prediction_unit_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_update.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_update.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_update.cpp	(revision 98)
@@ -23,32 +23,69 @@
   {
     log_begin(Prediction_unit_Glue,FUNCTION);
+    log_function(Prediction_unit_Glue,FUNCTION,_name.c_str());
 
-//     for (uint32_t i=0; i<_param->_nb_inst_branch_update; i++)
-//       {
-// 	Tcontrol_t btb_ack     = PORT_READ(in_UPDATE_BTB_ACK [i]);
-// 	Tcontrol_t dir_ack     = PORT_READ(in_UPDATE_DIR_ACK [i]);
-// 	Tcontrol_t ras_ack     = PORT_READ(in_UPDATE_RAS_ACK [i]);
-// 	Tcontrol_t upt_val     = PORT_READ(in_UPDATE_UPT_VAL [i]);
+    for (uint32_t i=0; i<_param->_nb_inst_branch_update; i++)
+      {
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"  * UPDATE [%d]",i);
+	Tcontrol_t btb_ack = PORT_READ(in_UPDATE_BTB_ACK [i]);
+	Tcontrol_t dir_ack = PORT_READ(in_UPDATE_DIR_ACK [i]);
+	Tcontrol_t ras_ack = PORT_READ(in_UPDATE_RAS_ACK [i]);
+	Tcontrol_t upt_val = PORT_READ(in_UPDATE_UPT_VAL [i]);
 
-// 	Tcontrol_t need_btb = PORT_READ(in_UPDATE_UPT_BTB_VAL [i]);
-// 	Tcontrol_t need_dir = PORT_READ(in_UPDATE_UPT_DIR_VAL [i]);
-// 	Tcontrol_t need_ras = PORT_READ(in_UPDATE_UPT_RAS_VAL [i]);
+	Tcontrol_t upt_btb_val = PORT_READ(in_UPDATE_UPT_BTB_VAL [i]);
+	Tcontrol_t upt_dir_val = PORT_READ(in_UPDATE_UPT_DIR_VAL [i]);
+	Tcontrol_t upt_ras_val = PORT_READ(in_UPDATE_UPT_RAS_VAL [i]);
 	
-// 	PORT_WRITE(out_UPDATE_BTB_VAL [i], (upt_val and need_btb and
-// 					    (not need_dir or (need_dir and dir_ack)) and
-// 					    (not need_ras or (need_ras and ras_ack))));
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * upt_val               : %d",upt_val);
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * upt_btb_val - btb_ack : %d - %d",upt_btb_val, btb_ack);
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * upt_dir_val - dir_ack : %d - %d",upt_dir_val, dir_ack);
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * upt_ras_val - ras_ack : %d - %d",upt_ras_val, ras_ack);
 
-// 	PORT_WRITE(out_UPDATE_DIR_VAL [i], (upt_val and need_dir and
-// 					    (not need_btb or (need_btb and btb_ack)) and
-// 					    (not need_ras or (need_ras and ras_ack))));
+	Tcontrol_t btb_val = (upt_val  and
+                              upt_btb_val and
+//                            upt_dir_val and
+//                            upt_ras_val and
+// 			      (not upt_btb_val or (upt_btb_val and btb_ack)) and
+			      (not upt_dir_val or (upt_dir_val and dir_ack)) and
+			      (not upt_ras_val or (upt_ras_val and ras_ack))
+                              );
 
-// 	PORT_WRITE(out_UPDATE_RAS_VAL [i], (upt_val and need_ras and
-// 					    (not need_btb or (need_btb and btb_ack)) and
-// 					    (not need_dir or (need_dir and dir_ack))));
+	Tcontrol_t dir_val = (upt_val and 
+//                            upt_btb_val and
+                              upt_dir_val and
+//                            upt_ras_val and
+			      (not upt_btb_val or (upt_btb_val and btb_ack)) and
+// 			      (not upt_dir_val or (upt_dir_val and dir_ack)) and
+			      (not upt_ras_val or (upt_ras_val and ras_ack))
+                              );
 
-// 	PORT_WRITE(out_UPDATE_UPT_ACK [i], ((not need_btb or (need_btb and btb_ack)) and
-// 					    (not need_dir or (need_dir and dir_ack)) and
-// 					    (not need_ras or (need_ras and ras_ack))));
-//       }
+	Tcontrol_t ras_val = (upt_val  and
+//                            upt_btb_val and
+//                            upt_dir_val and
+                              upt_ras_val and
+			      (not upt_btb_val or (upt_btb_val and btb_ack)) and
+			      (not upt_dir_val or (upt_dir_val and dir_ack))//  and
+// 			      (not upt_ras_val or (upt_ras_val and ras_ack))
+                              );
+
+	Tcontrol_t upt_ack = (
+//                            upt_val  and
+//                            upt_btb_val and
+//                            upt_dir_val and
+//                            upt_ras_val and
+			      (not upt_btb_val or (upt_btb_val and btb_ack)) and
+			      (not upt_dir_val or (upt_dir_val and dir_ack)) and
+			      (not upt_ras_val or (upt_ras_val and ras_ack))
+                              );
+
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    *     btb_val           : %d",btb_val);
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    *     dir_val           : %d",dir_val);
+        log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    *     ras_val           : %d",ras_val);
+
+        PORT_WRITE(out_UPDATE_BTB_VAL [i], btb_val);
+        PORT_WRITE(out_UPDATE_DIR_VAL [i], dir_val);
+        PORT_WRITE(out_UPDATE_RAS_VAL [i], ras_val);
+        PORT_WRITE(out_UPDATE_UPT_ACK [i], upt_ack);
+      }
 
     log_end(Prediction_unit_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 98)
@@ -79,5 +79,5 @@
   ALLOC1_SC_SIGNAL( in_BRANCH_COMPLETE_DEPTH              ," in_BRANCH_COMPLETE_DEPTH              ",Tdepth_t           ,_param->_nb_inst_branch_complete);
   ALLOC1_SC_SIGNAL( in_BRANCH_COMPLETE_ADDRESS            ," in_BRANCH_COMPLETE_ADDRESS            ",Taddress_t         ,_param->_nb_inst_branch_complete);
-  ALLOC1_SC_SIGNAL( in_BRANCH_COMPLETE_FLAG               ," in_BRANCH_COMPLETE_FLAG               ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
+  ALLOC1_SC_SIGNAL( in_BRANCH_COMPLETE_NO_SEQUENCE        ," in_BRANCH_COMPLETE_NO_SEQUENCE        ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
   ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_MISS_PREDICTION    ,"out_BRANCH_COMPLETE_MISS_PREDICTION    ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
   ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_TAKE               ,"out_BRANCH_COMPLETE_TAKE               ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
@@ -88,5 +88,5 @@
   ALLOC1_SC_SIGNAL( in_BRANCH_EVENT_ACK                   ," in_BRANCH_EVENT_ACK                   ",Tcontrol_t         ,_param->_nb_context);
 //ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_CONTEXT_ID            ,"out_BRANCH_EVENT_CONTEXT_ID            ",Tcontext_t         ,_param->_nb_context);
-//ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_DEPTH                 ,"out_BRANCH_EVENT_DEPTH                 ",Tdepth_t           ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_DEPTH                 ,"out_BRANCH_EVENT_DEPTH                 ",Tdepth_t           ,_param->_nb_context);
 //ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_MISS_PREDICTION       ,"out_BRANCH_EVENT_MISS_PREDICTION       ",Tcontrol_t         ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_ADDRESS_SRC           ,"out_BRANCH_EVENT_ADDRESS_SRC           ",Taddress_t         ,_param->_nb_context);
@@ -145,5 +145,5 @@
   INSTANCE1_SC_SIGNAL(_Prediction_unit, in_BRANCH_COMPLETE_DEPTH              ,_param->_nb_inst_branch_complete);
   INSTANCE1_SC_SIGNAL(_Prediction_unit, in_BRANCH_COMPLETE_ADDRESS            ,_param->_nb_inst_branch_complete);
-  INSTANCE1_SC_SIGNAL(_Prediction_unit, in_BRANCH_COMPLETE_FLAG               ,_param->_nb_inst_branch_complete);
+  INSTANCE1_SC_SIGNAL(_Prediction_unit, in_BRANCH_COMPLETE_NO_SEQUENCE        ,_param->_nb_inst_branch_complete);
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_MISS_PREDICTION    ,_param->_nb_inst_branch_complete);
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_TAKE               ,_param->_nb_inst_branch_complete);
@@ -155,5 +155,6 @@
 //if (_param->_have_port_context_id)
 //INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_CONTEXT_ID            ,_param->_nb_context);
-//INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_DEPTH                 ,_param->_nb_context);
+  if (_param->_have_port_depth)
+  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_DEPTH                 ,_param->_nb_context);
 //INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_MISS_PREDICTION       ,_param->_nb_context);
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_ADDRESS_SRC           ,_param->_nb_context);
@@ -351,5 +352,5 @@
   DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_DEPTH          ,_param->_nb_inst_branch_complete);
   DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_ADDRESS        ,_param->_nb_inst_branch_complete);
-  DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_FLAG           ,_param->_nb_inst_branch_complete);
+  DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_NO_SEQUENCE    ,_param->_nb_inst_branch_complete);
   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_MISS_PREDICTION,_param->_nb_inst_branch_complete);
   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_TAKE           ,_param->_nb_inst_branch_complete);
@@ -360,5 +361,5 @@
   DELETE1_SC_SIGNAL( in_BRANCH_EVENT_ACK              ,_param->_nb_context);
 //DELETE1_SC_SIGNAL(out_BRANCH_EVENT_CONTEXT_ID       ,_param->_nb_context);
-//DELETE1_SC_SIGNAL(out_BRANCH_EVENT_DEPTH            ,_param->_nb_context);
+  DELETE1_SC_SIGNAL(out_BRANCH_EVENT_DEPTH            ,_param->_nb_context);
 //DELETE1_SC_SIGNAL(out_BRANCH_EVENT_MISS_PREDICTION  ,_param->_nb_context);
   DELETE1_SC_SIGNAL(out_BRANCH_EVENT_ADDRESS_SRC      ,_param->_nb_context);
